// SPDX-License-Identifier: Apache-2.0 or MIT
//

pub const SYSCALLS: &[(&str, i32)] = &[
    ("_llseek", -10026),
    ("_newselect", -10032),
    ("_sysctl", 149),
    ("accept", -105),
    ("accept4", -118),
    ("access", 33),
    ("acct", 51),
    ("add_key", 278),
    ("adjtimex", 124),
    ("afs_syscall", 137),
    ("alarm", 27),
    ("arch_prctl", -10001),
    ("arm_fadvise64_64", -10083),
    ("arm_sync_file_range", -10084),
    ("bdflush", 134),
    ("bind", -102),
    ("bpf", 351),
    ("break", -10003),
    ("breakpoint", -10182),
    ("brk", 45),
    ("cachectl", -10103),
    ("cacheflush", -10104),
    ("capget", 184),
    ("capset", 185),
    ("chdir", 12),
    ("chmod", 15),
    ("chown", 212),
    ("chown32", -10004),
    ("chroot", 61),
    ("clock_adjtime", 337),
    ("clock_adjtime64", -10212),
    ("clock_getres", 261),
    ("clock_getres_time64", -10213),
    ("clock_gettime", 260),
    ("clock_gettime64", -10214),
    ("clock_nanosleep", 262),
    ("clock_nanosleep_time64", -10215),
    ("clock_settime", 259),
    ("clock_settime64", -10216),
    ("clone", 120),
    ("clone3", 435),
    ("close", 6),
    ("close_range", 436),
    ("connect", -103),
    ("copy_file_range", 375),
    ("creat", 8),
    ("create_module", 127),
    ("delete_module", 129),
    ("dup", 41),
    ("dup2", 63),
    ("dup3", 326),
    ("epoll_create", 249),
    ("epoll_create1", 327),
    ("epoll_ctl", 250),
    ("epoll_ctl_old", -10005),
    ("epoll_pwait", 312),
    ("epoll_pwait2", 441),
    ("epoll_wait", 251),
    ("epoll_wait_old", -10006),
    ("eventfd", 318),
    ("eventfd2", 323),
    ("execve", 11),
    ("execveat", 354),
    ("exit", 1),
    ("exit_group", 248),
    ("faccessat", 300),
    ("faccessat2", 439),
    ("fadvise64", 253),
    ("fadvise64_64", -10007),
    ("fallocate", 314),
    ("fanotify_init", 332),
    ("fanotify_mark", 333),
    ("fchdir", 133),
    ("fchmod", 94),
    ("fchmodat", 299),
    ("fchown", 207),
    ("fchown32", -10008),
    ("fchownat", 291),
    ("fcntl", 55),
    ("fcntl64", -10009),
    ("fdatasync", 148),
    ("fgetxattr", 229),
    ("finit_module", 344),
    ("flistxattr", 232),
    ("flock", 143),
    ("fork", 2),
    ("fremovexattr", 235),
    ("fsconfig", 431),
    ("fsetxattr", 226),
    ("fsmount", 432),
    ("fsopen", 430),
    ("fspick", 433),
    ("fstat", 108),
    ("fstat64", -10010),
    ("fstatat64", -10011),
    ("fstatfs", 100),
    ("fstatfs64", 266),
    ("fsync", 118),
    ("ftime", -10013),
    ("ftruncate", 93),
    ("ftruncate64", -10014),
    ("futex", 238),
    ("futex_time64", -10222),
    ("futimesat", 292),
    ("get_kernel_syms", 130),
    ("get_mempolicy", 269),
    ("get_robust_list", 305),
    ("get_thread_area", -10076),
    ("get_tls", -10204),
    ("getcpu", 311),
    ("getcwd", 183),
    ("getdents", 141),
    ("getdents64", 220),
    ("getegid", 202),
    ("getegid32", -10015),
    ("geteuid", 201),
    ("geteuid32", -10016),
    ("getgid", 200),
    ("getgid32", -10017),
    ("getgroups", 205),
    ("getgroups32", -10018),
    ("getitimer", 105),
    ("getpeername", -107),
    ("getpgid", 132),
    ("getpgrp", 65),
    ("getpid", 20),
    ("getpmsg", 188),
    ("getppid", 64),
    ("getpriority", 96),
    ("getrandom", 349),
    ("getresgid", 211),
    ("getresgid32", -10019),
    ("getresuid", 209),
    ("getresuid32", -10020),
    ("getrlimit", 191),
    ("getrusage", 77),
    ("getsid", 147),
    ("getsockname", -106),
    ("getsockopt", -115),
    ("gettid", 236),
    ("gettimeofday", 78),
    ("getuid", 199),
    ("getuid32", -10021),
    ("getxattr", 227),
    ("gtty", -10022),
    ("idle", 112),
    ("init_module", 128),
    ("inotify_add_watch", 285),
    ("inotify_init", 284),
    ("inotify_init1", 324),
    ("inotify_rm_watch", 286),
    ("io_cancel", 247),
    ("io_destroy", 244),
    ("io_getevents", 245),
    ("io_pgetevents", 382),
    ("io_pgetevents_time64", -10223),
    ("io_setup", 243),
    ("io_submit", 246),
    ("io_uring_enter", 426),
    ("io_uring_register", 427),
    ("io_uring_setup", 425),
    ("ioctl", 54),
    ("ioperm", -10094),
    ("iopl", -10095),
    ("ioprio_get", 283),
    ("ioprio_set", 282),
    ("ipc", 117),
    ("kcmp", 343),
    ("kexec_file_load", 381),
    ("kexec_load", 277),
    ("keyctl", 280),
    ("kill", 37),
    ("landlock_add_rule", 445),
    ("landlock_create_ruleset", 444),
    ("landlock_restrict_self", 446),
    ("lchown", 198),
    ("lchown32", -10025),
    ("lgetxattr", 228),
    ("link", 9),
    ("linkat", 296),
    ("listen", -104),
    ("listxattr", 230),
    ("llistxattr", 231),
    ("lock", -10027),
    ("lookup_dcookie", 110),
    ("lremovexattr", 234),
    ("lseek", 19),
    ("lsetxattr", 225),
    ("lstat", 107),
    ("lstat64", -10028),
    ("madvise", 219),
    ("mbind", 268),
    ("membarrier", 356),
    ("memfd_create", 350),
    ("memfd_secret", -10244),
    ("migrate_pages", 287),
    ("mincore", 218),
    ("mkdir", 39),
    ("mkdirat", 289),
    ("mknod", 14),
    ("mknodat", 290),
    ("mlock", 150),
    ("mlock2", 374),
    ("mlockall", 152),
    ("mmap", 90),
    ("mmap2", -10029),
    ("modify_ldt", -10098),
    ("mount", 21),
    ("mount_setattr", 442),
    ("move_mount", 429),
    ("move_pages", 310),
    ("mprotect", 125),
    ("mpx", -10030),
    ("mq_getsetattr", 276),
    ("mq_notify", 275),
    ("mq_open", 271),
    ("mq_timedreceive", 274),
    ("mq_timedreceive_time64", -10225),
    ("mq_timedsend", 273),
    ("mq_timedsend_time64", -10226),
    ("mq_unlink", 272),
    ("mremap", 163),
    ("msgctl", -214),
    ("msgget", -213),
    ("msgrcv", -212),
    ("msgsnd", -211),
    ("msync", 144),
    ("multiplexer", -10186),
    ("munlock", 151),
    ("munlockall", 153),
    ("munmap", 91),
    ("name_to_handle_at", 335),
    ("nanosleep", 162),
    ("newfstatat", 293),
    ("nfsservctl", 169),
    ("nice", 34),
    ("oldfstat", -10034),
    ("oldlstat", -10035),
    ("oldolduname", -10036),
    ("oldstat", -10037),
    ("olduname", -10038),
    ("open", 5),
    ("open_by_handle_at", 336),
    ("open_tree", 428),
    ("openat", 288),
    ("openat2", 437),
    ("pause", 29),
    ("pciconfig_iobase", -10086),
    ("pciconfig_read", -10087),
    ("pciconfig_write", -10088),
    ("perf_event_open", 331),
    ("personality", 136),
    ("pidfd_getfd", 438),
    ("pidfd_open", 434),
    ("pidfd_send_signal", 424),
    ("pipe", 42),
    ("pipe2", 325),
    ("pivot_root", 217),
    ("pkey_alloc", 385),
    ("pkey_free", 386),
    ("pkey_mprotect", 384),
    ("poll", 168),
    ("ppoll", 302),
    ("ppoll_time64", -10230),
    ("prctl", 172),
    ("pread64", 180),
    ("preadv", 328),
    ("preadv2", 376),
    ("prlimit64", 334),
    ("process_madvise", 440),
    ("process_mrelease", 448),
    ("process_vm_readv", 340),
    ("process_vm_writev", 341),
    ("prof", -10039),
    ("profil", -10040),
    ("pselect6", 301),
    ("pselect6_time64", -10231),
    ("ptrace", 26),
    ("putpmsg", 189),
    ("pwrite64", 181),
    ("pwritev", 329),
    ("pwritev2", 377),
    ("query_module", 167),
    ("quotactl", 131),
    ("quotactl_fd", 443),
    ("read", 3),
    ("readahead", 222),
    ("readdir", 89),
    ("readlink", 85),
    ("readlinkat", 298),
    ("readv", 145),
    ("reboot", 88),
    ("recv", -110),
    ("recvfrom", -112),
    ("recvmmsg", -119),
    ("recvmmsg_time64", -10232),
    ("recvmsg", -117),
    ("remap_file_pages", 267),
    ("removexattr", 233),
    ("rename", 38),
    ("renameat", 295),
    ("renameat2", 347),
    ("request_key", 279),
    ("restart_syscall", 7),
    ("riscv_flush_icache", -10243),
    ("rmdir", 40),
    ("rseq", 383),
    ("rt_sigaction", 174),
    ("rt_sigpending", 176),
    ("rt_sigprocmask", 175),
    ("rt_sigqueueinfo", 178),
    ("rt_sigreturn", 173),
    ("rt_sigsuspend", 179),
    ("rt_sigtimedwait", 177),
    ("rt_sigtimedwait_time64", -10233),
    ("rt_tgsigqueueinfo", 330),
    ("rtas", -10187),
    ("s390_guarded_storage", 378),
    ("s390_pci_mmio_read", 353),
    ("s390_pci_mmio_write", 352),
    ("s390_runtime_instr", 342),
    ("s390_sthyi", 380),
    ("sched_get_priority_max", 159),
    ("sched_get_priority_min", 160),
    ("sched_getaffinity", 240),
    ("sched_getattr", 346),
    ("sched_getparam", 155),
    ("sched_getscheduler", 157),
    ("sched_rr_get_interval", 161),
    ("sched_rr_get_interval_time64", -10234),
    ("sched_setaffinity", 239),
    ("sched_setattr", 345),
    ("sched_setparam", 154),
    ("sched_setscheduler", 156),
    ("sched_yield", 158),
    ("seccomp", 348),
    ("security", -10042),
    ("select", 142),
    ("semctl", -203),
    ("semget", -202),
    ("semop", -201),
    ("semtimedop", -204),
    ("semtimedop_time64", -10235),
    ("send", -109),
    ("sendfile", 187),
    ("sendfile64", -10043),
    ("sendmmsg", -120),
    ("sendmsg", -116),
    ("sendto", -111),
    ("set_mempolicy", 270),
    ("set_robust_list", 304),
    ("set_thread_area", -10079),
    ("set_tid_address", 252),
    ("set_tls", -10183),
    ("setdomainname", 121),
    ("setfsgid", 216),
    ("setfsgid32", -10044),
    ("setfsuid", 215),
    ("setfsuid32", -10045),
    ("setgid", 214),
    ("setgid32", -10046),
    ("setgroups", 206),
    ("setgroups32", -10047),
    ("sethostname", 74),
    ("setitimer", 104),
    ("setns", 339),
    ("setpgid", 57),
    ("setpriority", 97),
    ("setregid", 204),
    ("setregid32", -10048),
    ("setresgid", 210),
    ("setresgid32", -10049),
    ("setresuid", 208),
    ("setresuid32", -10050),
    ("setreuid", 203),
    ("setreuid32", -10051),
    ("setrlimit", 75),
    ("setsid", 66),
    ("setsockopt", -114),
    ("settimeofday", 79),
    ("setuid", 213),
    ("setuid32", -10052),
    ("setxattr", 224),
    ("sgetmask", -10053),
    ("shmat", -221),
    ("shmctl", -224),
    ("shmdt", -222),
    ("shmget", -223),
    ("shutdown", -113),
    ("sigaction", 67),
    ("sigaltstack", 186),
    ("signal", 48),
    ("signalfd", 316),
    ("signalfd4", 322),
    ("sigpending", 73),
    ("sigprocmask", 126),
    ("sigreturn", 119),
    ("sigsuspend", 72),
    ("socket", -101),
    ("socketcall", 102),
    ("socketpair", -108),
    ("splice", 306),
    ("spu_create", -10188),
    ("spu_run", -10189),
    ("ssetmask", -10061),
    ("stat", 106),
    ("stat64", -10062),
    ("statfs", 99),
    ("statfs64", 265),
    ("statx", 379),
    ("stime", -10064),
    ("stty", -10065),
    ("subpage_prot", -10207),
    ("swapcontext", -10190),
    ("swapoff", 115),
    ("swapon", 87),
    ("switch_endian", -10191),
    ("symlink", 83),
    ("symlinkat", 297),
    ("sync", 36),
    ("sync_file_range", 307),
    ("sync_file_range2", -10089),
    ("syncfs", 338),
    ("sys_debug_setcontext", -10191),
    ("syscall", -10090),
    ("sysfs", 135),
    ("sysinfo", 116),
    ("syslog", 103),
    ("sysmips", -10106),
    ("tee", 308),
    ("tgkill", 241),
    ("time", -10108),
    ("timer_create", 254),
    ("timer_delete", 258),
    ("timer_getoverrun", 257),
    ("timer_gettime", 256),
    ("timer_gettime64", -10236),
    ("timer_settime", 255),
    ("timer_settime64", -10237),
    ("timerfd", 317),
    ("timerfd_create", 319),
    ("timerfd_gettime", 321),
    ("timerfd_gettime64", -10238),
    ("timerfd_settime", 320),
    ("timerfd_settime64", -10239),
    ("times", 43),
    ("tkill", 237),
    ("truncate", 92),
    ("truncate64", -10066),
    ("tuxcall", -10067),
    ("ugetrlimit", -10068),
    ("ulimit", -10069),
    ("umask", 60),
    ("umount", 22),
    ("umount2", 52),
    ("uname", 122),
    ("unlink", 10),
    ("unlinkat", 294),
    ("unshare", 303),
    ("uselib", 86),
    ("userfaultfd", 355),
    ("usr26", -10184),
    ("usr32", -10185),
    ("ustat", 62),
    ("utime", 30),
    ("utimensat", 315),
    ("utimensat_time64", -10240),
    ("utimes", 313),
    ("vfork", 190),
    ("vhangup", 111),
    ("vm86", -10071),
    ("vm86old", -10072),
    ("vmsplice", 309),
    ("vserver", -10082),
    ("wait4", 114),
    ("waitid", 281),
    ("waitpid", -10073),
    ("write", 4),
    ("writev", 146),
];
