// SPDX-License-Identifier: Apache-2.0 or MIT
//

pub const SYSCALLS: &[(&str, i32)] = &[
    ("_llseek", -10026),
    ("_newselect", -10032),
    ("_sysctl", 156),
    ("accept", 43),
    ("accept4", 288),
    ("access", 21),
    ("acct", 163),
    ("add_key", 248),
    ("adjtimex", 159),
    ("afs_syscall", 183),
    ("alarm", 37),
    ("arch_prctl", 158),
    ("arm_fadvise64_64", -10083),
    ("arm_sync_file_range", -10084),
    ("bdflush", -10002),
    ("bind", 49),
    ("bpf", 321),
    ("break", -10003),
    ("breakpoint", -10182),
    ("brk", 12),
    ("cachectl", -10103),
    ("cacheflush", -10104),
    ("capget", 125),
    ("capset", 126),
    ("chdir", 80),
    ("chmod", 90),
    ("chown", 92),
    ("chown32", -10004),
    ("chroot", 161),
    ("clock_adjtime", 305),
    ("clock_adjtime64", -10212),
    ("clock_getres", 229),
    ("clock_getres_time64", -10213),
    ("clock_gettime", 228),
    ("clock_gettime64", -10214),
    ("clock_nanosleep", 230),
    ("clock_nanosleep_time64", -10215),
    ("clock_settime", 227),
    ("clock_settime64", -10216),
    ("clone", 56),
    ("clone3", 435),
    ("close", 3),
    ("close_range", 436),
    ("connect", 42),
    ("copy_file_range", 326),
    ("creat", 85),
    ("create_module", 174),
    ("delete_module", 176),
    ("dup", 32),
    ("dup2", 33),
    ("dup3", 292),
    ("epoll_create", 213),
    ("epoll_create1", 291),
    ("epoll_ctl", 233),
    ("epoll_ctl_old", 214),
    ("epoll_pwait", 281),
    ("epoll_pwait2", 441),
    ("epoll_wait", 232),
    ("epoll_wait_old", 215),
    ("eventfd", 284),
    ("eventfd2", 290),
    ("execve", 59),
    ("execveat", 322),
    ("exit", 60),
    ("exit_group", 231),
    ("faccessat", 269),
    ("faccessat2", 439),
    ("fadvise64", 221),
    ("fadvise64_64", -10007),
    ("fallocate", 285),
    ("fanotify_init", 300),
    ("fanotify_mark", 301),
    ("fchdir", 81),
    ("fchmod", 91),
    ("fchmodat", 268),
    ("fchown", 93),
    ("fchown32", -10008),
    ("fchownat", 260),
    ("fcntl", 72),
    ("fcntl64", -10009),
    ("fdatasync", 75),
    ("fgetxattr", 193),
    ("finit_module", 313),
    ("flistxattr", 196),
    ("flock", 73),
    ("fork", 57),
    ("fremovexattr", 199),
    ("fsconfig", 431),
    ("fsetxattr", 190),
    ("fsmount", 432),
    ("fsopen", 430),
    ("fspick", 433),
    ("fstat", 5),
    ("fstat64", -10010),
    ("fstatat64", -10011),
    ("fstatfs", 138),
    ("fstatfs64", -10012),
    ("fsync", 74),
    ("ftime", -10013),
    ("ftruncate", 77),
    ("ftruncate64", -10014),
    ("futex", 202),
    ("futex_time64", -10222),
    ("futimesat", 261),
    ("get_kernel_syms", 177),
    ("get_mempolicy", 239),
    ("get_robust_list", 274),
    ("get_thread_area", 211),
    ("get_tls", -10204),
    ("getcpu", 309),
    ("getcwd", 79),
    ("getdents", 78),
    ("getdents64", 217),
    ("getegid", 108),
    ("getegid32", -10015),
    ("geteuid", 107),
    ("geteuid32", -10016),
    ("getgid", 104),
    ("getgid32", -10017),
    ("getgroups", 115),
    ("getgroups32", -10018),
    ("getitimer", 36),
    ("getpeername", 52),
    ("getpgid", 121),
    ("getpgrp", 111),
    ("getpid", 39),
    ("getpmsg", 181),
    ("getppid", 110),
    ("getpriority", 140),
    ("getrandom", 318),
    ("getresgid", 120),
    ("getresgid32", -10019),
    ("getresuid", 118),
    ("getresuid32", -10020),
    ("getrlimit", 97),
    ("getrusage", 98),
    ("getsid", 124),
    ("getsockname", 51),
    ("getsockopt", 55),
    ("gettid", 186),
    ("gettimeofday", 96),
    ("getuid", 102),
    ("getuid32", -10021),
    ("getxattr", 191),
    ("gtty", -10022),
    ("idle", -10023),
    ("init_module", 175),
    ("inotify_add_watch", 254),
    ("inotify_init", 253),
    ("inotify_init1", 294),
    ("inotify_rm_watch", 255),
    ("io_cancel", 210),
    ("io_destroy", 207),
    ("io_getevents", 208),
    ("io_pgetevents", 333),
    ("io_pgetevents_time64", -10223),
    ("io_setup", 206),
    ("io_submit", 209),
    ("io_uring_enter", 426),
    ("io_uring_register", 427),
    ("io_uring_setup", 425),
    ("ioctl", 16),
    ("ioperm", 173),
    ("iopl", 172),
    ("ioprio_get", 252),
    ("ioprio_set", 251),
    ("ipc", -10024),
    ("kcmp", 312),
    ("kexec_file_load", 320),
    ("kexec_load", 246),
    ("keyctl", 250),
    ("kill", 62),
    ("landlock_add_rule", 445),
    ("landlock_create_ruleset", 444),
    ("landlock_restrict_self", 446),
    ("lchown", 94),
    ("lchown32", -10025),
    ("lgetxattr", 192),
    ("link", 86),
    ("linkat", 265),
    ("listen", 50),
    ("listxattr", 194),
    ("llistxattr", 195),
    ("lock", -10027),
    ("lookup_dcookie", 212),
    ("lremovexattr", 198),
    ("lseek", 8),
    ("lsetxattr", 189),
    ("lstat", 6),
    ("lstat64", -10028),
    ("madvise", 28),
    ("mbind", 237),
    ("membarrier", 324),
    ("memfd_create", 319),
    ("memfd_secret", 447),
    ("migrate_pages", 256),
    ("mincore", 27),
    ("mkdir", 83),
    ("mkdirat", 258),
    ("mknod", 133),
    ("mknodat", 259),
    ("mlock", 149),
    ("mlock2", 325),
    ("mlockall", 151),
    ("mmap", 9),
    ("mmap2", -10029),
    ("modify_ldt", 154),
    ("mount", 165),
    ("mount_setattr", 442),
    ("move_mount", 429),
    ("move_pages", 279),
    ("mprotect", 10),
    ("mpx", -10030),
    ("mq_getsetattr", 245),
    ("mq_notify", 244),
    ("mq_open", 240),
    ("mq_timedreceive", 243),
    ("mq_timedreceive_time64", -10225),
    ("mq_timedsend", 242),
    ("mq_timedsend_time64", -10226),
    ("mq_unlink", 241),
    ("mremap", 25),
    ("msgctl", 71),
    ("msgget", 68),
    ("msgrcv", 70),
    ("msgsnd", 69),
    ("msync", 26),
    ("multiplexer", -10186),
    ("munlock", 150),
    ("munlockall", 152),
    ("munmap", 11),
    ("name_to_handle_at", 303),
    ("nanosleep", 35),
    ("newfstatat", 262),
    ("nfsservctl", 180),
    ("nice", -10033),
    ("oldfstat", -10034),
    ("oldlstat", -10035),
    ("oldolduname", -10036),
    ("oldstat", -10037),
    ("olduname", -10038),
    ("open", 2),
    ("open_by_handle_at", 304),
    ("open_tree", 428),
    ("openat", 257),
    ("openat2", 437),
    ("pause", 34),
    ("pciconfig_iobase", -10086),
    ("pciconfig_read", -10087),
    ("pciconfig_write", -10088),
    ("perf_event_open", 298),
    ("personality", 135),
    ("pidfd_getfd", 438),
    ("pidfd_open", 434),
    ("pidfd_send_signal", 424),
    ("pipe", 22),
    ("pipe2", 293),
    ("pivot_root", 155),
    ("pkey_alloc", 330),
    ("pkey_free", 331),
    ("pkey_mprotect", 329),
    ("poll", 7),
    ("ppoll", 271),
    ("ppoll_time64", -10230),
    ("prctl", 157),
    ("pread64", 17),
    ("preadv", 295),
    ("preadv2", 327),
    ("prlimit64", 302),
    ("process_madvise", 440),
    ("process_mrelease", 448),
    ("process_vm_readv", 310),
    ("process_vm_writev", 311),
    ("prof", -10039),
    ("profil", -10040),
    ("pselect6", 270),
    ("pselect6_time64", -10231),
    ("ptrace", 101),
    ("putpmsg", 182),
    ("pwrite64", 18),
    ("pwritev", 296),
    ("pwritev2", 328),
    ("query_module", 178),
    ("quotactl", 179),
    ("quotactl_fd", 443),
    ("read", 0),
    ("readahead", 187),
    ("readdir", -10041),
    ("readlink", 89),
    ("readlinkat", 267),
    ("readv", 19),
    ("reboot", 169),
    ("recv", -110),
    ("recvfrom", 45),
    ("recvmmsg", 299),
    ("recvmmsg_time64", -10232),
    ("recvmsg", 47),
    ("remap_file_pages", 216),
    ("removexattr", 197),
    ("rename", 82),
    ("renameat", 264),
    ("renameat2", 316),
    ("request_key", 249),
    ("restart_syscall", 219),
    ("riscv_flush_icache", -10243),
    ("rmdir", 84),
    ("rseq", 334),
    ("rt_sigaction", 13),
    ("rt_sigpending", 127),
    ("rt_sigprocmask", 14),
    ("rt_sigqueueinfo", 129),
    ("rt_sigreturn", 15),
    ("rt_sigsuspend", 130),
    ("rt_sigtimedwait", 128),
    ("rt_sigtimedwait_time64", -10233),
    ("rt_tgsigqueueinfo", 297),
    ("rtas", -10187),
    ("s390_guarded_storage", -10205),
    ("s390_pci_mmio_read", -10197),
    ("s390_pci_mmio_write", -10198),
    ("s390_runtime_instr", -10196),
    ("s390_sthyi", -10206),
    ("sched_get_priority_max", 146),
    ("sched_get_priority_min", 147),
    ("sched_getaffinity", 204),
    ("sched_getattr", 315),
    ("sched_getparam", 143),
    ("sched_getscheduler", 145),
    ("sched_rr_get_interval", 148),
    ("sched_rr_get_interval_time64", -10234),
    ("sched_setaffinity", 203),
    ("sched_setattr", 314),
    ("sched_setparam", 142),
    ("sched_setscheduler", 144),
    ("sched_yield", 24),
    ("seccomp", 317),
    ("security", 185),
    ("select", 23),
    ("semctl", 66),
    ("semget", 64),
    ("semop", 65),
    ("semtimedop", 220),
    ("semtimedop_time64", -10235),
    ("send", -109),
    ("sendfile", 40),
    ("sendfile64", -10043),
    ("sendmmsg", 307),
    ("sendmsg", 46),
    ("sendto", 44),
    ("set_mempolicy", 238),
    ("set_robust_list", 273),
    ("set_thread_area", 205),
    ("set_tid_address", 218),
    ("set_tls", -10183),
    ("setdomainname", 171),
    ("setfsgid", 123),
    ("setfsgid32", -10044),
    ("setfsuid", 122),
    ("setfsuid32", -10045),
    ("setgid", 106),
    ("setgid32", -10046),
    ("setgroups", 116),
    ("setgroups32", -10047),
    ("sethostname", 170),
    ("setitimer", 38),
    ("setns", 308),
    ("setpgid", 109),
    ("setpriority", 141),
    ("setregid", 114),
    ("setregid32", -10048),
    ("setresgid", 119),
    ("setresgid32", -10049),
    ("setresuid", 117),
    ("setresuid32", -10050),
    ("setreuid", 113),
    ("setreuid32", -10051),
    ("setrlimit", 160),
    ("setsid", 112),
    ("setsockopt", 54),
    ("settimeofday", 164),
    ("setuid", 105),
    ("setuid32", -10052),
    ("setxattr", 188),
    ("sgetmask", -10053),
    ("shmat", 30),
    ("shmctl", 31),
    ("shmdt", 67),
    ("shmget", 29),
    ("shutdown", 48),
    ("sigaction", -10054),
    ("sigaltstack", 131),
    ("signal", -10055),
    ("signalfd", 282),
    ("signalfd4", 289),
    ("sigpending", -10056),
    ("sigprocmask", -10057),
    ("sigreturn", -10058),
    ("sigsuspend", -10059),
    ("socket", 41),
    ("socketcall", -10060),
    ("socketpair", 53),
    ("splice", 275),
    ("spu_create", -10188),
    ("spu_run", -10189),
    ("ssetmask", -10061),
    ("stat", 4),
    ("stat64", -10062),
    ("statfs", 137),
    ("statfs64", -10063),
    ("statx", 332),
    ("stime", -10064),
    ("stty", -10065),
    ("subpage_prot", -10207),
    ("swapcontext", -10190),
    ("swapoff", 168),
    ("swapon", 167),
    ("switch_endian", -10191),
    ("symlink", 88),
    ("symlinkat", 266),
    ("sync", 162),
    ("sync_file_range", 277),
    ("sync_file_range2", -10089),
    ("syncfs", 306),
    ("sys_debug_setcontext", -10191),
    ("syscall", -10090),
    ("sysfs", 139),
    ("sysinfo", 99),
    ("syslog", 103),
    ("sysmips", -10106),
    ("tee", 276),
    ("tgkill", 234),
    ("time", 201),
    ("timer_create", 222),
    ("timer_delete", 226),
    ("timer_getoverrun", 225),
    ("timer_gettime", 224),
    ("timer_gettime64", -10236),
    ("timer_settime", 223),
    ("timer_settime64", -10237),
    ("timerfd", -10107),
    ("timerfd_create", 283),
    ("timerfd_gettime", 287),
    ("timerfd_gettime64", -10238),
    ("timerfd_settime", 286),
    ("timerfd_settime64", -10239),
    ("times", 100),
    ("tkill", 200),
    ("truncate", 76),
    ("truncate64", -10066),
    ("tuxcall", 184),
    ("ugetrlimit", -10068),
    ("ulimit", -10069),
    ("umask", 95),
    ("umount", -10070),
    ("umount2", 166),
    ("uname", 63),
    ("unlink", 87),
    ("unlinkat", 263),
    ("unshare", 272),
    ("uselib", 134),
    ("userfaultfd", 323),
    ("usr26", -10184),
    ("usr32", -10185),
    ("ustat", 136),
    ("utime", 132),
    ("utimensat", 280),
    ("utimensat_time64", -10240),
    ("utimes", 235),
    ("vfork", 58),
    ("vhangup", 153),
    ("vm86", -10071),
    ("vm86old", -10072),
    ("vmsplice", 278),
    ("vserver", 236),
    ("wait4", 61),
    ("waitid", 247),
    ("waitpid", -10073),
    ("write", 1),
    ("writev", 20),
];
